﻿/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/

using System;
using System.Collections.Generic;
using System.Text;
using moxa;

namespace DIO
{
    class Program
    {
        static void Main(string[] args)
        {
            int i = 0;
            int port = 0, value = 0, value2 = 0;
            string sdout = "";

            System.Console.WriteLine("Digitial In/Out Test Program");
            System.Console.WriteLine("\t (0) Exit Program");
            System.Console.WriteLine("\t (1) Display DIN");
            System.Console.WriteLine("\t (2) Display DOUT");
            System.Console.WriteLine("\t (3) Set DOUT value");
            System.Console.WriteLine("\t (4) Display both DIN and DOUT");

            // read a char.
            string sin = System.Console.ReadLine();
            int n = int.Parse(sin);
            do
            {
                switch (n)
                {
                    // if char == '1', display the Din0 ~ Din3
                    case 1:
                        for (i = 0; i < 4; i++)
                        {
                            value = moxa.w406.DigitalInput.Get(i);
                            System.Console.WriteLine("Din{0}={1}", i, value);
                        }
                        break;
                    // if char == '2', display the Dout0 ~ Dout3
                    case 2:
                        for (i = 0; i < 4; i++)
                        {
                            value = moxa.w406.DigitalOutput.Get(i);
                            System.Console.WriteLine("DOut{0}={1}", i, value);
                        }
                        break;

                    // if char == '3', show all (DIN & DOUT)
                    case 3:
                        // read port Nnmber from console
                        System.Console.Write("Input the DOut Port Number (0 ~ 7) = ");
                        sdout = System.Console.ReadLine();
                        port = int.Parse(sdout);

                        // read port value from console
                        System.Console.Write("Input the DOut value (0 or 1) = ");
                        sdout = System.Console.ReadLine();
                        value = int.Parse(sdout);

                        // set the new value to the specified port
                        if (!moxa.w406.DigitalOutput.Set(port, value))
                        {
                            System.Console.WriteLine("set dout fail!");
                            break;
                        }

                        // display the new Dout value.
                        for (i = 0; i < 4; i++)
                        {
                            value = moxa.w406.DigitalOutput.Get(i);
                            System.Console.WriteLine("DOut{0}={1}", i, value);
                        }
                        break;

                    // if char == '4', display all of the Din and DOut value.
                    case 4:
                        for (i = 0; i < 4; i++)
                        {
                            value = moxa.w406.DigitalInput.Get(i);
                            value2 = moxa.w406.DigitalOutput.Get(i);
                            System.Console.WriteLine("DIn{0}={1}  DOut{0}={2}", i, value, value2);
                        }
                        break;
                }
                sin = System.Console.ReadLine();
                n = int.Parse(sin);
            } while (n != 0);
        }
    }
}
