﻿/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/

using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using moxa;


namespace SyncNTP
{
    class Program
    {
        public const UInt32 FILE_DEVICE_HAL = 0x00000101;
        public const UInt32 FILE_DEVICE_CONSOLE = 0x00000102;
        public const UInt32 FILE_DEVICE_PSL = 0x00000103;
        public const UInt32 FILE_DEVICE_SERVICE = 0x00000104;
        public const UInt32 FILE_DEVICE_NLED = 0x00000105;
        public const UInt32 FILE_DEVICE_NOTIFY = 0x00000106;

        public const UInt32 METHOD_BUFFERED = 0;
        public const UInt32 METHOD_IN_DIRECT = 1;
        public const UInt32 METHOD_OUT_DIRECT = 2;
        public const UInt32 METHOD_NEITHER = 3;

        public const UInt32 FILE_ANY_ACCESS = 0;
        public const UInt32 FILE_READ_ACCESS = (0x0001);    // file & pipe
        public const UInt32 FILE_WRITE_ACCESS = (0x0002);    // file & pipe

        public static uint IOCTL_SERVICE_CONTROL = CTL_CODE(FILE_DEVICE_SERVICE, 7, METHOD_BUFFERED, FILE_ANY_ACCESS);

        static void Main(string[] args)
        {
            moxa.mxdevice dev = new moxa.mxdevice("NTP0:");

            if (dev.Open())
            {
                string szSync = "sync";
                int nBytesReturn = 0;
                int nSize = szSync.Length;

                IntPtr lpstr = Marshal.AllocHGlobal(nSize);
                Marshal.StringToBSTR(szSync);

                dev.DeviceIoControl(IOCTL_SERVICE_CONTROL, lpstr, nSize, IntPtr.Zero, 0, ref nBytesReturn, IntPtr.Zero);

                Marshal.FreeHGlobal(lpstr);

                dev.Close();
            }
        }

        private static uint CTL_CODE(uint DeviceType, uint Function, uint Method, uint Access)
        {
            return ((DeviceType << 16) | (Access << 14) | (Function << 2) | Method);
        }
    }
}
