﻿/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/

using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using moxa;


namespace gprs_diagnose
{
    class Program
    {
        static void Main(string[] args)
        {

            int i = 0, errorCode = 0;
            moxa.w406.GPRS gprs = new moxa.w406.GPRS();
            errorCode = gprs.Diagnose();

            for (i = 0; i < 7; i++)
            {
                switch (errorCode & (0x1 << i))
                {
                    case (int)moxa.w406.GPRS.GPRS_ERROR_BAUDRATE_COM3:
                        Console.WriteLine("COM3: Error\n");
                        break;
                    case (int)moxa.w406.GPRS.GPRS_ERROR_BAUDRATE_COM4:
                        Console.WriteLine("COM4: Error\n");
                        break;
                    case (int)moxa.w406.GPRS.GPRS_ERROR_FLOWCONTROL:
                        Console.WriteLine("GPRS Module Flow Control Error\n");
                        break;
                    case (int)moxa.w406.GPRS.GPRS_ERROR_PINCODE:
                        Console.WriteLine("PIN Code Error\n");
                        break;
                    case (int)moxa.w406.GPRS.GPRS_ERROR_TEMPERATURE:
                        Console.WriteLine("Temperature Error:\n");
                        break;
                    case (int)moxa.w406.GPRS.GPRS_ERROR_SIGNAL_STRENGTH:
                        Console.WriteLine("Signal Strength Error\n");
                        break;
                    case (int)moxa.w406.GPRS.GPRS_ERROR_RADIOBAND:
                        Console.WriteLine("Radio Band Error\n");
                        break;
                    case (int)moxa.w406.GPRS.GPRS_ERROR_MODULE:
                        Console.WriteLine("GPRS Module Error\n");
                        break;
                    default:
                        break;
                }
            }
        }
    }
}
