/*  Copyright (C) MOXA Inc. All rights reserved.

    This software is distributed under the terms of the
    MOXA License.  See the file COPYING-MOXA for details.
*/

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>

#include <winsock2.h>

#define CS_ERROR 1
#define CS_OK 0

void sError(char*);

#define IP_ERROR	0xFFFEFFFFL
#define INTERVAL	1
#define RETRY		5000

unsigned long dot2ip(char *dot)
{
	unsigned long	ip;
	unsigned char	*c;
	int		i, d;

	c = (unsigned char *)&ip;
	for (i = 4; i-- > 0; ) {
		d = *dot++ - '0';
		if (d < 0 || d > 9)
			return IP_ERROR;
		while (*dot >= '0' && *dot <= '9') {
			d = d * 10 + *dot++ - '0';
			if (d > 255)
				return IP_ERROR;
		}
		*c++ = d;
		if (*dot++ != '.')
			break;
	}
	if (*--dot || i)
		return IP_ERROR;
	return ip;
}

int _tmain(int argc, _TCHAR* argv[])
{
	WORD version;
	WSADATA wsaData;
	int rVal=0;

	version = MAKEWORD(1,1);

	WSAStartup(version,(LPWSADATA)&wsaData);

	if ( argc != 2 ) {
		printf("syntax: tcp_wince xxx.xxx.xxx.xxx\n",argv[1]);
		return 0;
	}

	char szIP[100];
	memset(szIP,0,sizeof(szIP));
	WideCharToMultiByte(CP_ACP, 0, argv[1], wcslen(argv[1]), szIP, sizeof(szIP), 0, 0);

	unsigned long ip = dot2ip(szIP);
	if (ip == IP_ERROR) {
	    printf("Invalid IP address %s!\n",argv[1]);
	    return 1;
	}

	//create the socket
	SOCKET theSocket = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);

	if(theSocket == SOCKET_ERROR)
	{
		sError("Failed socket()");
		return CS_ERROR;
	}

	//Fill in the sockaddr_in struct
	SOCKADDR_IN serverInfo;

	serverInfo.sin_family = PF_INET;
//	serverInfo.sin_addr = *((LPIN_ADDR)*hostEntry->h_addr_list);
	serverInfo.sin_addr.s_addr = ip;
	serverInfo.sin_port = htons(8888);

	rVal=connect(theSocket,(LPSOCKADDR)&serverInfo, sizeof(serverInfo));
	if(rVal==SOCKET_ERROR)
	{
		sError("Failed connect()");
		return CS_ERROR;
	}

	//char *buf = "simpleservermessage\n";
	//char buf[MAX_PATH];
	char *buf = NULL;
	buf = new char[256 * 256];

	for ( unsigned int i=0; i<256 * 256; i++)
		buf[i] = i % 256;

	while (1)
	{
		//memset(buf,0,65000);
		//scanf("%s", buf);
		//rVal = send(theSocket, buf, strlen(buf), 0);
		rVal = send(theSocket, buf, 256 * 256, 0);

		//if ( buf[0] == 'q' )
		//	break;
		if(rVal == SOCKET_ERROR)
		{
			sError("Failed send()");
			return CS_ERROR;
		}
		Sleep(500);
	}
	delete buf;

	closesocket(theSocket);
	//cout << "closing client"<< endl;
	WSACleanup();
	
	return CS_OK;
}

void sError(char *str)
{
	printf("%s:%s\n" , "SOCKET ERROR", str);
	WSACleanup();
}

