// sim_get_pin_status.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>
#include "moxa\devices.h"

void PrintUsage( void )
{
	wprintf( TEXT("Usage: sim_get_pin_status       ; Get SIM card status\r\n") );
	wprintf( TEXT("\r\n"));
}


BOOL getopt(int argc, _TCHAR* argv[], _TCHAR option, _TCHAR** value)
{
	int		i;
	BOOL	bolFound = FALSE;

	for (i = 1; (i < argc); i++)
	{
		if ( bolFound )
		{
			if ( value ) {
				*value = argv[i];
			}
			break;
		}
		if ((argv[i][0] == '-') || (argv[i][0] == '/'))
		{
			if ( argv[i][1] == option )
			{
				bolFound = TRUE;
			}
		}
	}

	return bolFound;
}

int _tmain(int argc, _TCHAR* argv[])
{
	int en_status=0;

	if ( getopt(argc, argv, 'h', NULL) ) {
		PrintUsage();
		return 0;
	}

	int h = cellular_modem_open();
	if ( h != 0 && h != -1 ) 
	{
		switch ( cellular_modem_sim_get_sim_card_status(h) ) 
		{
			case 0:
				printf("SIM Card is ready!\n");

				en_status = cellular_modem_sim_get_pin_enable_status(h);
				if ( en_status == 1 ) {
					printf("PIN code authentication is enabled!\n");
				} else {
					printf("PIN code authentication is disabled!\n");
				}
				break;
			case 1:
				printf("No SIM Card detected.\n");
				break;
			case 2:
				printf("Need PIN code authentication.\n");
				break;
			case 3:
				printf("Need PUK code authentication.\n");
				break;
		}

		cellular_modem_close(h);
	}
	return 0;
}

