// sms_remove_msg.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>
#include "moxa\devices.h"

void PrintUsage( void )
{
	wprintf( TEXT("Usage: sms_remove_msg [-h] | [ -i index]\r\n") );
	wprintf( TEXT("\t\tRemove a message for the specific index\r\n"));
	wprintf( TEXT(" e.g.: sms_remove_msg -h      ; display this message\r\n") );
	wprintf( TEXT("     : sms_remove_msg -i 1    ; Delete the Message of Index 1\r\n") );
}


BOOL getopt(int argc, _TCHAR* argv[], _TCHAR option, _TCHAR** value)
{
	int		i;
	BOOL	bolFound = FALSE;

	for (i = 1; (i < argc); i++)
	{
		if ( bolFound )
		{
			if ( value ) {
				*value = argv[i];
			}
			break;
		}
		if ((argv[i][0] == '-') || (argv[i][0] == '/'))
		{
			if ( argv[i][1] == option )
			{
				bolFound = TRUE;
			}
		}
	}

	return bolFound;
}

int _tmain(int argc, _TCHAR* argv[])
{
	TCHAR *szIndex=NULL;
	int   nIndex = -1;

	if ( argc == 1 ) {
		PrintUsage();
		return 0;
	}
	if ( getopt(argc, argv, 'h', NULL) ) {
		PrintUsage();
		return 0;
	}
	if ( getopt(argc, argv, 'i', &szIndex) ) {
		if ( szIndex ) {
			nIndex = wcstol( szIndex, NULL, 10 ); 
		}
	}

	if ( nIndex > 0 ) 
	{
		int h = cellular_modem_open();
		if ( h != 0 && h != -1 ) 
		{
			if ( cellular_modem_sim_get_sim_card_status(h) == 0 ) 
			{
				if ( cellular_modem_sms_delete_message(h, nIndex) == 0 )
				{
					wprintf( L"The message was removed.\n");
				}
			} else {
				printf( "SIM Card is not ready.\n");
			}
			cellular_modem_close(h);
		}
	} 
	else 
	{
		PrintUsage();
		return -1;
	}

	return 0;
}

