// sms_send_text.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>
#include "moxa\devices.h"

void PrintUsage( void )
{
	wprintf( TEXT("Usage: sms_send_text_msg [-h] | [ -n Phone_Number -t \"Text_Message\"]\r\n") );
	wprintf( TEXT("\t\tSend a text message to a specific number\r\n"));
	wprintf( TEXT(" e.g.: sms_send_text_msg -h      ; display this message\r\n") );
	wprintf( TEXT("     : sms_send_text_msg -n +886911345678 -t \"Hello, how are you.\" ; Send Message\r\n") );
}


BOOL getopt(int argc, _TCHAR* argv[], _TCHAR option, _TCHAR** value)
{
	int		i;
	BOOL	bolFound = FALSE;

	for (i = 1; (i < argc); i++)
	{
		if ( bolFound )
		{
			if ( value ) {
				*value = argv[i];
			}
			break;
		}
		if ((argv[i][0] == '-') || (argv[i][0] == '/'))
		{
			if ( argv[i][1] == option )
			{
				bolFound = TRUE;
			}
		}
	}

	return bolFound;
}

int _tmain(int argc, _TCHAR* argv[])
{
	SMSMSG msg;
	TCHAR *szNumber=NULL, *szMsg=NULL;
	char  *csNumber = NULL;
	char  *csMsg = NULL;

	if ( argc == 1 ) {
		PrintUsage();
		return 0;
	}
	if ( getopt(argc, argv, 'h', NULL) ) {
		PrintUsage();
		return 0;
	}
	if ( getopt(argc, argv, 'n', &szNumber) ) {
		if ( szNumber ) {
			csNumber = new char[MAX_PATH];
			memset(csNumber, 0, sizeof(csNumber));
			//WideCharToMultiByte(CP_ACP, 0, szNumber, NULL, csNumber, MAX_PATH, NULL, NULL);
			wcstombs(csNumber, szNumber, MAX_PATH);
		}
	}
	if ( getopt(argc, argv, 't', &szMsg) ) {
		if ( szMsg ) {
			csMsg = new char[MAX_PATH];
			memset(csMsg, 0, sizeof(csMsg));
			//WideCharToMultiByte(CP_ACP, 0, szMsg, NULL, csMsg, MAX_PATH, NULL, NULL);
			wcstombs(csMsg, szMsg, MAX_PATH);
		}
	}

	if ( szMsg && szNumber ) 
	{
		memset( &msg, 0, sizeof(msg));
		msg.msg_length = strlen(csMsg);
		if ( strlen(csNumber) >= 20 ) 
		{
			wprintf( TEXT("Phone Number is too long, it must be less than 20 characters.\r\n") );
		}
		else if ( strlen(csMsg) >= 140 ) 
		{
			wprintf( TEXT("Text Message is too long, it must be less than 140 characters.\r\n") );
		} 
		else 
		{
			strcpy( msg.phone_number, csNumber );
			strcpy( msg.msg_text, csMsg );

			int h = cellular_modem_open();
			if ( h != 0 && h != -1 ) 
			{
				if ( cellular_modem_sim_get_sim_card_status(h) == 0 ) 
				{
					if ( cellular_modem_sms_send_message(h, 0, &msg) == 0 )
					{
						printf( "SMS sent.\n");
					}
				} else {
					printf( "SIM Card is not ready.\n");
				}
				cellular_modem_close(h);
			}
		}
	} 
	else 
	{
		PrintUsage();
	}

	if ( szNumber ) {
		delete csNumber;
	}
	if ( szMsg ) {
		delete csMsg;
	}

	return 0;
}

